//
//  ClassVC.swift
//  FantasyCycling
//
//  Created by KaKa on 28/11/14.
//  Copyright (c) 2014 Marc Calm. All rights reserved.
//

import UIKit

class ClassVC: UIViewController {

    //col·leccio de punts totals usuaris
    var UsersPointsCollection = [UsersPoints]()
    
    //servei que retorna punts dels usuaris
    var service:UsersPointsService!
    
    @IBOutlet weak var tableViewClass: UITableView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.tableViewClass.registerClass(UITableViewCell.self, forCellReuseIdentifier: "cell")
        
        UIApplication.sharedApplication().networkActivityIndicatorVisible = true
        service = UsersPointsService()
        
        service.getPoints {
            (response) in
            self.loadPoints(response as NSArray)
        }
        // Do any additional setup after loading the view.
    }

    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(true)
        self.navigationController?.navigationBar.topItem?.title="Classification"
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */
    
    
    func tableView(tableViewClass: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        println("You selected cell #\(indexPath.row)!")
    }
    
    func tableView(tableViewClass: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        
        var cell = tableViewClass.dequeueReusableCellWithIdentifier("cela", forIndexPath: indexPath) as UsersPointsCustomCell
        
        let points = UsersPointsCollection[indexPath.row]
        
        cell.user.text = points.user
        cell.mountainP.text = String(points.PM)
        cell.generalP.text = String(points.PE)
        cell.totalP.text = String(points.Total)
        cell.pos.text=String(indexPath.row+1)

        return cell
    }
    
    
    func tableView(tableViewClass: UITableView, numberOfRowsInSection section: Int) -> Int {
        return UsersPointsCollection.count;
    }
    
    func tableView(tableViewClass: UITableView, heightForRowAtIndexPath
        indexPath: NSIndexPath) -> CGFloat {
            return tableViewClass.rowHeight;
    }
    
    func colorForIndex(index: Int) -> UIColor {
        let itemCount = UsersPointsCollection.count;
        let val = (CGFloat(index) / CGFloat(itemCount)) * 0.6

        return UIColor(red: 235, green: 91, blue: val, alpha: 1.0)

    }
    
    func tableView(tableViewClass: UITableView, willDisplayCell cell: UITableViewCell,
        forRowAtIndexPath indexPath: NSIndexPath) {
            cell.backgroundColor = colorForIndex(indexPath.row)
    }
    
    //funcio que retorna els corredors i punts i omple la taula
    func loadPoints(UsersP:NSArray) {
        var i: Int = 0
        var nomComplet : String
        
        var user:String
        var PM:Int
        var PE:Int
        var Total:Int
        
        for points in UsersP {
            
            var user = points["user"]! as String
            var PM = (points["PM"]! as String).toInt()!
            var PE = (points["PE"]! as String).toInt()!
            var Total = (points["Total"]! as String).toInt()!
            
            
            var PointsObj = UsersPoints(user: user,PM: PM, PE: PE, Total: Total)
            UsersPointsCollection.append(PointsObj)
            
            
            i += 1
            dispatch_async(dispatch_get_main_queue()) {
                self.tableViewClass.reloadData()
            }
            
        }
        UIApplication.sharedApplication().networkActivityIndicatorVisible = false
    }
    
    

    


}
