//
//  MyTeamVC.swift
//  SwiftLoginScreen
//
//  Created by KaKa on 18/11/14.
//  Copyright (c) 2014 Marc Calm. All rights reserved.
//

import UIKit

class MyTeamVC: UIViewController {

    @IBOutlet weak var myTeamTV: UITableView!
    
    
    //col·leccio de corredors
    var teamPointsCollection = [TeamPoints]()
    
    //servei que retorna els corredors
    var service:TeamPointsService!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        UIApplication.sharedApplication().networkActivityIndicatorVisible = true
        
        service = TeamPointsService()
        
        service.getPoints {
            (response) in
            self.loadPoints(response as NSArray)
        }
        // Do any additional setup after loading the view.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func tableView(
        tableView: UITableView!,
        cellForRowAtIndexPath indexPath: NSIndexPath!)
        -> UITableViewCell! {
            
            var cell = myTeamTV.dequeueReusableCellWithIdentifier("cell", forIndexPath: indexPath) as TeamCustomCell
            
            let points = teamPointsCollection[indexPath.row]
            
            cell.rider.text = points.Rider
            cell.mountainP.text = String(points.PM)
            cell.generalP.text = String(points.PE)
            cell.totalP.text = String(points.Total)

            
            
            return cell
  
            
    }
    
    func tableView(
        tableView: UITableView!,
        numberOfRowsInSection section: Int) -> Int {
            
            return teamPointsCollection.count
    }
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */
    
    //funcio que retorna els corredors i omple la taula
    func loadPoints(points:NSArray) {
        var i: Int = 0
        var nomComplet : String
        
        var id:Int
        var Rider:String
        var Type:String
        var idCiclista:String
        var PM:Int
        var PE:Int
        var Total:Int
        var username:String

        let prefs:NSUserDefaults = NSUserDefaults.standardUserDefaults()

        for teamPoints in points {

            var id = (teamPoints["idUsuari"]! as String).toInt()!
            var Rider = teamPoints["Rider"]! as String
            var Type = teamPoints["Type"]! as String
            var idCiclista = teamPoints["idCiclista"]? as String
            var PM = (teamPoints["PM"]! as String).toInt()!
            var PE = (teamPoints["PE"]! as String).toInt()!
            var Total = (teamPoints["Total"]! as String).toInt()!
            var username = teamPoints["username"]! as String
            
            let user : NSString = prefs.valueForKey("USERNAME") as NSString
            
            if username == user {
                var teamPointsObj = TeamPoints(id: id, Rider: Rider, Type: Type, idCiclista: idCiclista,PM: PM, PE: PE, Total: Total, username: username)
                teamPointsCollection.append(teamPointsObj)
            }
            
            //nomComplet = nom + " " + cognom
            //model!.idRider[i] = String(id)
            //model!.options[i] = nomComplet
                
            i += 1
            dispatch_async(dispatch_get_main_queue()) {
                self.myTeamTV.reloadData()
            }
            
        }
        UIApplication.sharedApplication().networkActivityIndicatorVisible = false
    }
//accio per eliminar l'equip.

    
    @IBAction func deleteTeamBtn(sender: UIBarButtonItem) {
        
        var refreshAlert = UIAlertController(title: "Refresh", message: "All data will be lost.", preferredStyle: UIAlertControllerStyle.Alert)
        
        refreshAlert.addAction(UIAlertAction(title: "Ok", style: .Default, handler: { (action: UIAlertAction!) in
            UIApplication.sharedApplication().networkActivityIndicatorVisible = true
            self.eliminarEquip()
            self.myTeamTV.reloadData()
            UIApplication.sharedApplication().networkActivityIndicatorVisible = false
            
        }))
        
        refreshAlert.addAction(UIAlertAction(title: "Cancel", style: .Default, handler: { (action: UIAlertAction!) in
            
        }))
        
        presentViewController(refreshAlert, animated: true, completion: nil)
        
    }
    
    func eliminarEquip(){

            
            var idUsuari : String = ""
            let prefs:NSUserDefaults = NSUserDefaults.standardUserDefaults()
            let isLoggedIn:Int = prefs.integerForKey("ISLOGGEDIN") as Int
            if (isLoggedIn != 1) {
                self.performSegueWithIdentifier("goto_login", sender: self)
            } else {
                idUsuari = prefs.valueForKey("USERNAME") as NSString
                //Session.idUsuari = prefs.valueForKey("USERNAME") as NSString
            }
            
            
            var post:NSString = "idUsuari=\(idUsuari)"
            
            NSLog("PostData: %@",post);
            
            var url:NSURL = NSURL(string: "http://fantasycycling.esy.es/jsonDeleteTeam.php")!
            
            var postData:NSData = post.dataUsingEncoding(NSASCIIStringEncoding)!
            
            var postLength:NSString = String( postData.length )
            
            var request:NSMutableURLRequest = NSMutableURLRequest(URL: url)
            request.HTTPMethod = "POST"
            request.HTTPBody = postData
            request.setValue(postLength, forHTTPHeaderField: "Content-Length")
            request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
            request.setValue("application/json", forHTTPHeaderField: "Accept")
            
            
            var reponseError: NSError?
            var response: NSURLResponse?
            
            var urlData: NSData? = NSURLConnection.sendSynchronousRequest(request, returningResponse:&response, error:&reponseError)
            
            if ( urlData != nil ) {
                let res = response as NSHTTPURLResponse!;
                
                NSLog("Response code: %ld", res.statusCode);
                
                if (res.statusCode >= 200 && res.statusCode < 300)
                {
                    var responseData:NSString  = NSString(data:urlData!, encoding:NSUTF8StringEncoding)!
                    
                    NSLog("Response ==> %@", responseData);
                    
                    var error: NSError?
                    
                    let jsonData:NSDictionary = NSJSONSerialization.JSONObjectWithData(urlData!, options:NSJSONReadingOptions.MutableContainers , error: &error) as NSDictionary
                    
                    
                    let success:NSInteger = jsonData.valueForKey("success") as NSInteger
                    
                    //[jsonData[@"success"] integerValue];
                    
                    NSLog("Success: %ld", success);
                    
                    if(success == 1)
                    {
                        NSLog("Team Deleted.");
                        self.dismissViewControllerAnimated(true, completion: nil)
                        var alertView:UIAlertView = UIAlertView()
                        alertView.title = "Finish"
                        alertView.message = "Team Deleted!"
                        alertView.delegate = self
                        alertView.addButtonWithTitle("OK")
                        alertView.show()
                    } else {
                        var error_msg:NSString
                        
                        if jsonData["error_message"] as? NSString != nil {
                            error_msg = jsonData["error_message"] as NSString
                        } else {
                            error_msg = "Unknown Error"
                        }
                        var alertView:UIAlertView = UIAlertView()
                        alertView.title = "Delete team Failed!"
                        alertView.message = error_msg
                        alertView.delegate = self
                        alertView.addButtonWithTitle("OK")
                        alertView.show()
                        
                    }
                    
                } else {
                    var alertView:UIAlertView = UIAlertView()
                    alertView.title = "Delete team Failed!"
                    alertView.message = "Connection Failed"
                    alertView.delegate = self
                    alertView.addButtonWithTitle("OK")
                    alertView.show()
                }
            }  else {
                var alertView:UIAlertView = UIAlertView()
                alertView.title = "Delete team Failed!"
                alertView.message = "Connection Failure"
                if let error = reponseError {
                    alertView.message = (error.localizedDescription)
                }
                alertView.delegate = self
                alertView.addButtonWithTitle("OK")
                alertView.show()
        }
        
    }
    
}
