//
//  OverallPVC.swift
//  FantasyCyclingGame
//
//  Created by KaKa on 9/12/14.
//  Copyright (c) 2014 KaKa. All rights reserved.
//

import UIKit

class OverallPVC: UIViewController {

    //col·leccio de punts totals
    var OverCollection = [OverallPoints]()
    
    //servei que retorna punts dels corredors
    var service:OverallPointsService!

    @IBOutlet weak var OverallTV: UITableView!
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        UIApplication.sharedApplication().networkActivityIndicatorVisible = true
        service = OverallPointsService()
        
        service.getPoints {
            (response) in
            self.loadPoints(response as NSArray)
        }

        // Do any additional setup after loading the view.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */
    
    func tableView(
        tableView: UITableView!,
        cellForRowAtIndexPath indexPath: NSIndexPath!)
        -> UITableViewCell! {
            
            var cell = OverallTV.dequeueReusableCellWithIdentifier("cell", forIndexPath: indexPath) as OverallPCustomCell
            
            let points = OverCollection[indexPath.row]
            
            cell.rider.text = points.Rider
            cell.mountainP.text = String(points.PM)
            cell.generalP.text = String(points.PE)
            cell.totalP.text = String(points.Total)
            
            
            
            return cell
            
            
    }
    
    func tableView(
        tableView: UITableView!,
        numberOfRowsInSection section: Int) -> Int {
            
            return OverCollection.count
    }
    
    
    func tableView(tableViewClass: UITableView, heightForRowAtIndexPath
        indexPath: NSIndexPath) -> CGFloat {
            return tableViewClass.rowHeight;
    }
    
    func colorForIndex(index: Int) -> UIColor {
        let itemCount = OverCollection.count;
        let val = (CGFloat(index) / CGFloat(itemCount)) * 0.9
        
        return UIColor(red: 0.88+val, green: 0.27+val, blue: 0.14+val, alpha: 1.0)
        
    }
    
    func tableView(tableViewClass: UITableView, willDisplayCell cell: UITableViewCell,
        forRowAtIndexPath indexPath: NSIndexPath) {
            cell.backgroundColor = colorForIndex(indexPath.row)
    }
    
    
    //funcio que retorna els corredors i punts i omple la taula
    func loadPoints(OverallP:NSArray) {
        var i: Int = 0
        var nomComplet : String
        
        var Rider:String
        var Type:String
        var idCiclista:String
        var PM:Int
        var PE:Int
        var Total:Int
        
        let prefs:NSUserDefaults = NSUserDefaults.standardUserDefaults()
        
        for points in OverallP {
            
            var Rider = points["Rider"]! as String
            //var Type = points["Type"]! as String
            var idCiclista = points["idCiclista"]? as String
            var PM = (points["PM"]! as String).toInt()!
            var PE = (points["PE"]! as String).toInt()!
            var Total = (points["Total"]! as String).toInt()!
            
            
            var PointsObj = OverallPoints(Rider: Rider, idCiclista: idCiclista,PM: PM, PE: PE, Total: Total)
            OverCollection.append(PointsObj)
            
            
            i += 1
            dispatch_async(dispatch_get_main_queue()) {
                self.OverallTV.reloadData()
            }
            
        }
        UIApplication.sharedApplication().networkActivityIndicatorVisible = false
    }


}
