//
//  OverallPointsService.swift
//  FantasyCyclingGame
//
//  Created by KaKa on 9/12/14.
//  Copyright (c) 2014 KaKa. All rights reserved.
//

import Foundation

class OverallPointsService {
    
    var settings:Settings!
    
    init() {
        self.settings = Settings()
    }
    
    func getPoints(callback:(NSArray) -> ()) {
        request(settings.viewOverallPoints, callback: callback)
    }
    
    func request(url:String, callback:(NSArray)->()) {
        
        var nsURL = NSURL(string: url)
        
        let task = NSURLSession.sharedSession().dataTaskWithURL(nsURL!) {
            (data, response, error) in
            var error:NSError?
            var response = NSJSONSerialization.JSONObjectWithData(data, options: NSJSONReadingOptions.MutableContainers, error: &error) as NSArray
            callback(response)
        }
        
        task.resume()
        
    }
    
}
