//
//  RidersVC.swift
//  FantasyCycling
//
//  Created by KaKa on 3/12/14.
//  Copyright (c) 2014 Marc Calm. All rights reserved.
//

import UIKit

class RidersVC: UIViewController {

    //col·leccio de corredors
    var ridersCollection = [Rider]()
    
    //servei que retorna els corredors
    var service:RiderService!
    
    //load de la taula amb els corredors
    @IBOutlet weak var RidersTV: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        UIApplication.sharedApplication().networkActivityIndicatorVisible = true
        service = RiderService()

        service.getRiders {
            (response) in
            self.loadRiders(response as NSArray)
        }

        // Do any additional setup after loading the view.
    }

    //funcio que retorna els corredors i omple la taula
    func loadRiders(riders:NSArray) {
        var i: Int = 0
        var nomComplet : String
        for rider in riders {
            if model!.typeRider.toInt()! == (rider["idType"]! as String).toInt()! {
                
            
                var id = (rider["idCiclista"]! as String).toInt()!
                var nom = rider["nom"]! as String
                var cognom = rider["cognom"]! as String
                //var cognom2 = rider["cognom2"]? as String
                var idType = (rider["idType"]! as String).toInt()!

                var riderObj = Rider(id: id, nom: nom, congom: cognom, cognom2: "",type: idType)
                ridersCollection.append(riderObj)
                nomComplet = nom + " " + cognom
                model!.idRider[i] = String(id)
                model!.options[i] = nomComplet

                i += 1
                dispatch_async(dispatch_get_main_queue()) {
                    self.RidersTV.reloadData()
                }
            }
        }
        UIApplication.sharedApplication().networkActivityIndicatorVisible = false
    }

    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    //configuracio titul de la cela
    var model: DetailModel? {
        didSet {
            navigationItem.title = "Select " + model!.title
        }
    }
    
     func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        return 1
    }
    
     func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        //if model!.options.count == 0 {
            return ridersCollection.count
        //}
        //else {
        //    return model!.options.count
        //}
    }
    
    //configuracio del la fila marcada amb check.
     func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = RidersTV.dequeueReusableCellWithIdentifier("option", forIndexPath: indexPath) as UITableViewCell
        
        let rider = ridersCollection[indexPath.row]
        
        cell.textLabel!.text = rider.nom + " " + rider.cognom
        if (model!.selectedOptionIndex == indexPath.row) {
            cell.accessoryType = .Checkmark
        } else {
            cell.accessoryType = .None
        }


        return cell
    }
    
    //guardem la fila seleccionada al model pq despres es pugui veure al master.
     func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        let priorSelectedCell = tableView.cellForRowAtIndexPath(NSIndexPath(forRow: model!.selectedOptionIndex, inSection: 0))
        priorSelectedCell?.accessoryType = .None
        model!.selectedOptionIndex = indexPath.row
        let selectedCell = tableView.cellForRowAtIndexPath(indexPath)
        selectedCell?.accessoryType = .Checkmark
    }
    
   
}
