//
//  SelectTeamCustomCell.swift
//  FantasyCycling
//
//  Created by KaKa on 1/12/14.
//  Copyright (c) 2014 Marc Calm. All rights reserved.
//

import UIKit

class SelectTeamCustomCell: UITableViewCell {
    
    var model: DetailModel? {
        willSet {
            disconnectFromModel()
        }
        didSet {
            connectToModel()
            update()
        }
    }
    
    //per veure la linia seleccionada
    private lazy var selectedOptionIndexContext = UnsafeMutablePointer<Void>.alloc(1)
    
    //borrem quan ens desconectem
    private func disconnectFromModel() {
        model?.removeObserver(self, forKeyPath: "selectedOptionIndex", context: selectedOptionIndexContext)
    }
    //connectem
    private func connectToModel() {
        model?.addObserver(self, forKeyPath: "selectedOptionIndex", options: NSKeyValueObservingOptions(), context: selectedOptionIndexContext)
    }
    
    private class func toUnsafeMutablePointer(p: UnsafeMutablePointer<Void>) -> UnsafeMutablePointer<Void> {
        return p
    }
    //quan seleccionem passem la opcio al master
    override func observeValueForKeyPath(keyPath: String, ofObject object: AnyObject, change: [NSObject : AnyObject], context: UnsafeMutablePointer<Void>) {
        if (context == selectedOptionIndexContext) {
            update()
        } else {
            super.observeValueForKeyPath(keyPath, ofObject: object, change: change, context: context)
        }
    }
    //passem la opcio seleccionada
    private func update() {
        if (model != nil) {
            
            textLabel!.text = model?.title;
            detailTextLabel?.text = (model?.options[model!.selectedOptionIndex])?.description
            //detailTextLabel?.text = (model?.options.valueForKey("nom"))
        }
    }
    
    deinit {
        disconnectFromModel()
        selectedOptionIndexContext.dealloc(1)
    }


}
