//
//  SelectTeamVC.swift
//  FantasyCycling
//
//  Created by KaKa on 30/11/14.
//  Copyright (c) 2014 Marc Calm. All rights reserved.
//

import UIKit

class SelectTeamVC: UIViewController {

    
    
    @IBOutlet weak var SelectTeamTV: UITableView!
   
    @IBOutlet weak var buttonSave: UIBarButtonItem!

    let model = MasterModel()
    
    func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        return 1
    }
    //Numero de filas de la taula
    func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return model.details.count
    }
    //carrega la taula amb els resultats
    
    func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        
        let cell = SelectTeamTV.dequeueReusableCellWithIdentifier("detail", forIndexPath: indexPath) as MasterCell
        cell.model = model.details[indexPath.row]
        return cell
    }
    
    //mostrar detall inicial, ara ja no va.
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        if (segue.identifier == "ShowRiders") {
            prepareForShowDetailSegue(segue, sender:sender)
        }
    }
    //mostrar el detall
    private func prepareForShowDetailSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        let destination = segue.destinationViewController as RidersVC
        let cell = sender! as MasterCell
        destination.model = cell.model
    }

    //Funcio per guardar l'equip
    @IBAction func saveTeam(sender: UIBarButtonItem) {
        
        var leader: NSString = ""
        var sLeader: NSString = ""
        var climber: NSString = ""
        var young: NSString = ""
        var sprinter: NSString = ""
        var sprinter2: NSString = ""
        var free: NSString = ""
        var grega: NSString = ""
        var grega2: NSString = ""
        for var index = 0; index < 9; ++index {
            var indexPath = NSIndexPath(forRow: index, inSection: 0)
            var cell2 = self.SelectTeamTV.cellForRowAtIndexPath(indexPath) as MasterCell
            
            if index == 0 {
                leader  = cell2.labelID.text!
            }
            if index == 1 {
                sLeader = cell2.labelID.text!
            }
            if index == 2 {
                climber = cell2.labelID.text!
            }
            if index == 3 {
                young  = cell2.labelID.text!
            }
            if index == 4 {
                sprinter = cell2.labelID.text!
            }
            
            if index == 5 {
                sprinter2 = cell2.labelID.text!
            }
            if index == 6 {
                free  = cell2.labelID.text!
            }
            if index == 7 {
                grega = cell2.labelID.text!
            }
            if index == 8 {
                grega2 = cell2.labelID.text!
            }
            
        }
        
        //comprovacions abans de guardar
        if ( leader.isEqualToString("") || sLeader.isEqualToString("") || climber.isEqualToString("") || young.isEqualToString("") || free.isEqualToString("") || sprinter.isEqualToString("") || sprinter2.isEqualToString("") || grega.isEqualToString("") || grega2.isEqualToString("") ) {
            
            var alertView:UIAlertView = UIAlertView()
            alertView.title = "Failed!"
            alertView.message = "Team is not complete."
            alertView.delegate = self
            alertView.addButtonWithTitle("OK")
            alertView.show()
            
        } else {
            
            var idUsuari : String = ""
            let prefs:NSUserDefaults = NSUserDefaults.standardUserDefaults()
            let isLoggedIn:Int = prefs.integerForKey("ISLOGGEDIN") as Int
            if (isLoggedIn != 1) {
                self.performSegueWithIdentifier("goto_login", sender: self)
            } else {
                idUsuari = prefs.valueForKey("USERNAME") as NSString
                //Session.idUsuari = prefs.valueForKey("USERNAME") as NSString
            }
            
            
            var post:NSString = "idUsuari=\(idUsuari)&leader=\(leader)&sLeader=\(sLeader)&climber=\(climber)&young=\(young)&sprinter=\(sprinter)&sprinter2=\(sprinter2)&free=\(free)&grega=\(grega)&grega2=\(grega2)"
            
            NSLog("PostData: %@",post);
            
            var url:NSURL = NSURL(string: "http://fantasycycling.esy.es/jsonInsertTeam.php")!
            
            var postData:NSData = post.dataUsingEncoding(NSASCIIStringEncoding)!
            
            var postLength:NSString = String( postData.length )
            
            var request:NSMutableURLRequest = NSMutableURLRequest(URL: url)
            request.HTTPMethod = "POST"
            request.HTTPBody = postData
            request.setValue(postLength, forHTTPHeaderField: "Content-Length")
            request.setValue("application/x-www-form-urlencoded", forHTTPHeaderField: "Content-Type")
            request.setValue("application/json", forHTTPHeaderField: "Accept")
            
            
            var reponseError: NSError?
            var response: NSURLResponse?
            
            var urlData: NSData? = NSURLConnection.sendSynchronousRequest(request, returningResponse:&response, error:&reponseError)
            
            if ( urlData != nil ) {
                let res = response as NSHTTPURLResponse!;
                
                NSLog("Response code: %ld", res.statusCode);
                
                if (res.statusCode >= 200 && res.statusCode < 300)
                {
                    var responseData:NSString  = NSString(data:urlData!, encoding:NSUTF8StringEncoding)!
                    
                    NSLog("Response ==> %@", responseData);
                    
                    var error: NSError?
                    
                    let jsonData:NSDictionary = NSJSONSerialization.JSONObjectWithData(urlData!, options:NSJSONReadingOptions.MutableContainers , error: &error) as NSDictionary
                    
                    
                    let success:NSInteger = jsonData.valueForKey("success") as NSInteger
                    
                    //[jsonData[@"success"] integerValue];
                    
                    NSLog("Success: %ld", success);
                    
                    if(success == 1)
                    {
                        NSLog("Team CREATED");
                        self.dismissViewControllerAnimated(true, completion: nil)
                        var alertView:UIAlertView = UIAlertView()
                        alertView.title = "Perfect!"
                        alertView.message = "Team Created!"
                        alertView.delegate = self
                        alertView.addButtonWithTitle("OK")
                        alertView.show()
                    } else {
                        var error_msg:NSString
                        
                        if jsonData["error_message"] as? NSString != nil {
                            error_msg = jsonData["error_message"] as NSString
                        } else {
                            error_msg = "Unknown Error"
                        }
                        var alertView:UIAlertView = UIAlertView()
                        alertView.title = "Create team Failed!"
                        alertView.message = error_msg
                        alertView.delegate = self
                        alertView.addButtonWithTitle("OK")
                        alertView.show()
                        
                    }
                    
                } else {
                    var alertView:UIAlertView = UIAlertView()
                    alertView.title = "Create team Failed!"
                    alertView.message = "Connection Failed"
                    alertView.delegate = self
                    alertView.addButtonWithTitle("OK")
                    alertView.show()
                }
            }  else {
                var alertView:UIAlertView = UIAlertView()
                alertView.title = "Create team Failed!"
                alertView.message = "Connection Failure"
                if let error = reponseError {
                    alertView.message = (error.localizedDescription)
                }
                alertView.delegate = self
                alertView.addButtonWithTitle("OK")
                alertView.show()
            }
        }
        
        
    }
    
    

}
